/*
Name: Http.cpp
Copyright: GNU
Author:
Version: 1.0.0
Date: 8.6.2010
*/

#include <iostream>
#include "curl/curl.h"
#include <string>
#include <vector>
#include <stdlib.h>
#include <fstream>
#include <string.h>
#include "Http.h"
//#include "Log.h"
using namespace std;

Http::Http() {

}

void Http::addHeaders( vector<string> headers ) {
    request_header = headers;
}

int Http::requestGet( string url ) {
    CURL *curl;
    CURLcode result;
    char errorBuffer[CURL_ERROR_SIZE];
    string buffer;
    if ( curl = curl_easy_init() ) {
        curl_easy_setopt( curl, CURLOPT_ERRORBUFFER, errorBuffer );
        curl_easy_setopt( curl, CURLOPT_URL, url.c_str() );
        cout << "test1\n";
        if ( ! request_header.empty() ) {
            cout << "test2\n";
            for( int i = 0; i < request_header.size(); i++ ) {
                headers_define = curl_slist_append( headers_define, request_header[i].c_str() );
            }
            request_header.clear();
            curl_easy_setopt( curl, CURLOPT_HTTPHEADER, headers_define );
        }
        curl_easy_setopt( curl, CURLOPT_FOLLOWLOCATION, 1 );
        curl_easy_setopt( curl, CURLOPT_WRITEFUNCTION, &Http::contentWriter );
        curl_easy_setopt( curl, CURLOPT_WRITEDATA, &buffer );
        cout << "test3\n";
        result = curl_easy_perform( curl );
        cout << "test4\n";
        if ( ! request_header.empty() ) {
            curl_slist_free_all( Http::headers_define );
        }
        curl_easy_cleanup( curl );
    }
    if ( result == CURLE_OK ) {
        contentFormatted( buffer );
    } else {
        //Log::catchEvent( string("Curl Error: [") + string(result) + string("] - ") string(errorBuffer) );
        return -1;
    }
    return 0;
}

int Http::requestPost( string url, string post_fields, int ssl ) {
    CURL *curl;
    CURLcode result;
    char errorBuffer[CURL_ERROR_SIZE];
    string content, header;
    if ( curl = curl_easy_init() ) {
        curl_easy_setopt( curl, CURLOPT_ERRORBUFFER, errorBuffer );
        curl_easy_setopt( curl, CURLOPT_POSTFIELDS, post_fields.c_str() );
        curl_easy_setopt( curl, CURLOPT_URL, url.c_str() );
        curl_easy_setopt( curl, CURLOPT_HEADER, 1 );
        if ( ssl ) {
            curl_easy_setopt( curl, CURLOPT_HTTPPROXYTUNNEL, 1L );
        }
        if ( ! request_header.empty() ) {
            for( int i = 0; i < request_header.size(); i++ ) {
                headers_define = curl_slist_append( headers_define, request_header[i].c_str() );
            }
            request_header.clear();
            curl_easy_setopt( curl, CURLOPT_HTTPHEADER, headers_define );
        }
        curl_easy_setopt( curl, CURLOPT_HEADERFUNCTION, &Http::headerWriter );
        curl_easy_setopt( curl, CURLOPT_WRITEHEADER, &header );
        curl_easy_setopt( curl, CURLOPT_WRITEFUNCTION, &Http::contentWriter );
        curl_easy_setopt( curl, CURLOPT_WRITEDATA, &content );
        result = curl_easy_perform( curl );
        if ( ! request_header.empty() ) {
            curl_slist_free_all( Http::headers_define );
        }
        curl_easy_cleanup( curl );
    }
    if ( result == CURLE_OK ) {
        contentFormatted( content );
        headerFormatted( header );
    } else {
        //Log::catchEvent( string("Curl Error: [") + string(result) + string("] - ") string(errorBuffer) );
        return -1;
    }
    return 0;
}

int Http::contentWriter( char *data, size_t size, size_t nmemb, string *content ) {
    int result = 0;
    if ( content != NULL ) {
        content->append( data, size * nmemb );
        result = size * nmemb;
    }
    return result;
}

int Http::headerWriter( char *data, size_t size, size_t nmemb, string *header ) {
    int result = 0;
    if ( header != NULL ) {
        header->append( data, size * nmemb );
        result = size * nmemb;
    }
    return result;
}

void Http::contentFormatted( string buffer ) {
    char *row;
    response_content.clear();
    row = strtok( (char*)buffer.c_str(), "\n" );
    while( row != 0 ) {
        response_content.push_back( string(row) );
        row = strtok( 0, "\n" );
    }
}

void Http::headerFormatted( string header ) {
    char *row;
    response_header.clear();
    row = strtok( (char*)header.c_str(), "\n" );
    while( row != 0 ) {
        response_header.push_back( string(row) );
        row = strtok( 0, "\n" );
    }
}

string Http::getContentRow( int row ) {
    return response_content[row];
}

string Http::getHeaderRow( int row ) {
    return response_header[row];
}

vector <string> Http::getContent() {
    return response_content;
}

vector <string> Http::getHeader() {
    return response_header;
}

int Http::cleanContent() {
    if ( response_content.size() > 0 ) {
        response_content.clear();
        return 0;
    }
    return -1;
}

int Http::cleanHeader() {
    if ( response_header.size() > 0 ) {
        response_header.clear();
        return 0;
    }
    return -1;
}
