/*
Name: Http.h
Copyright: GNU
Author: 
Version: 1.0.0
Date: 8.6.2010
*/

#ifndef HTTP_H_
#define HTTP_H_

#include <string>
#include <vector>
#include <iostream>
#include "curl/curl.h"

class Http {

    public:

    Http();
    void addHeaders( std::vector <std::string> headers );
    int requestGet( std::string url );
    int requestPost( std::string url, std::string post_fields, int ssl = 0 );
    std::vector <std::string> getContent();
    std::vector <std::string> getHeader();
    std::string getContentRow( int row = 0 );
    std::string getHeaderRow( int row = 0 );
    int cleanContent();
    int cleanHeader();

    private:

    void contentFormatted( std::string content );
    void headerFormatted( std::string header );
    static int contentWriter( char *data, size_t size, size_t nmemb, std::string *content );
    static int headerWriter( char *data, size_t size, size_t nmemb, std::string *header );

    private:

    std::vector <std::string> response_content;
    std::vector <std::string> response_header;
    std::vector <std::string> request_header;
    struct curl_slist *headers_define;

};
#endif

/*
using example:

    Http *http;
    vector <string> content;
    http = new Http();
    http->requestGet( "http://www.azet.sk/" );
    content = http->getContent();
*/
